package com.wtkj.dto;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * @author Blizzard
 * @create at 2023-09-19 09:50
 * @describe
 */
@Data
public class ProjectTaskPageDTO implements Serializable {

	private static final long serialVersionUID = 1L;

	@NotNull(message = "projectId can't be null")
	@JsonSerialize(using = ToStringSerializer.class)
	private Long projectId;

	@NotNull(message = "stageId can't be null")
	@JsonSerialize(using = ToStringSerializer.class)
	private Long stageId;

	private String name;

	@ApiModelProperty(value = "当前登录用户的机构类型")
	@NotNull(message = "deptCategory can't be null")
	private Integer deptCategory;

	@ApiModelProperty(value = "当前登录用户的顶级机构id")
	@NotNull(message = "orgDeptId can't be null")
	private Long orgDeptId;

	private Integer taskStatus;

	@NotNull(message = "current can't be null")
	private Integer current;

	@NotNull(message = "size can't be null")
	private Integer size;

}
