package com.wtkj.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springblade.core.mp.base.BaseEntity;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;

/**
 * @author Blizzard
 * @create at 2023-09-23 11:05
 * @describe
 */
@Data
@TableName("blade_announcement")
@EqualsAndHashCode(callSuper = true)
public class Announcement extends BaseEntity {

	private static final long serialVersionUID = 1L;


	/**
	 * 标题
	 */
	@TableField("title")
	private String title;
	/**
	 * 内容
	 */
	@TableField("msg_content")
	private String msgContent;
	/**
	 * 开始时间
	 */
	@TableField("start_time")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private LocalDateTime startTime;

	/**
	 * 结束时间
	 */
	@TableField("end_time")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private LocalDateTime endTime;
	/**
	 * 优先级（L低，M中，H高）
	 */
	@TableField("priority")
	private String priority;
	/**
	 * 消息类型1:通知公告2:系统消息
	 */
	@TableField("msg_category")
	private Integer msgCategory;
	/**
	 * 通告对象类型（1:指定用户，2:全体用户）
	 */
	@TableField("msg_type")
	private Integer msgType;
	/**
	 * 发布状态（0未发布，1已发布，2已撤销）
	 */
	@TableField("send_status")
	private Integer sendStatus;
	/**
	 * 发布时间
	 */
	@TableField("send_time")
	private LocalDateTime sendTime;
	/**
	 * 撤销时间
	 */
	@TableField("cancel_time")
	private LocalDateTime cancelTime;
	/**
	 * 打开方式(组件：component 路由：url)
	 */
	@TableField("open_type")
	private String openType;
	/**
	 * 指定用户
	 */
	@TableField("user_ids")
	private String userIds;
	/**
	 * 摘要
	 */
	@TableField("msg_abstract")
	private String msgAbstract;
	/**
	 * 组件/路由 地址
	 */
	@TableField("open_page")
	private String openPage;

	@TableField("header")
	private String header = "asset";
}
