package com.wtkj.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springblade.core.mp.base.BaseEntity;

import javax.validation.constraints.NotNull;

/**
 * @author Blizzard
 * @create at 2023-09-26 11:20
 * @describe
 */
@EqualsAndHashCode(callSuper = true)
@Data
@TableName("blade_inner_file_and_folder")
public class InnerFileAndFolder extends BaseEntity {

	private static final long serialVersionUID = 1L;

	@JsonSerialize(using = ToStringSerializer.class)
	@TableField("dept_id")
	@NotNull(message = "deptId不可为空")
	private Long deptId;

	@JsonSerialize(using = ToStringSerializer.class)
	@TableField("parent_id")
	private Long parentId = 0L;

	@TableField("title")
	private String title;

	@TableField("type")
	@ApiModelProperty(value = "1：文件 2:文件夹")
	@NotNull(message = "type不可为空")
	private Integer type;

	@JsonSerialize(using = ToStringSerializer.class)
	@TableField("blade_file_id")
	private Long bladeFileId;

}
