package com.wtkj.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springblade.core.mp.base.BaseEntity;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotNull;
import java.util.Date;

/**
 * @author Blizzard
 * @create at 2023-09-13 16:15
 * @describe
 */
@EqualsAndHashCode(callSuper = true)
@Data
@TableName("blade_project_stage")
public class ProjectStage extends BaseEntity {

	private static final long serialVersionUID = 1L;

	@TableField("project_id")
	@JsonSerialize(using = ToStringSerializer.class)
	private Long projectId;

	@TableField("name")
	@ApiModelProperty("名称")
	private String name;

	@TableField("sort")
	@ApiModelProperty("排序")
	@NotNull(message = "sort不可为空")
	private Integer sort;

	@TableField("start_time")
	@ApiModelProperty("阶段周期开始时间")
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(pattern = "yyyy-MM-dd")
	private Date startTime;

	@TableField("end_time")
	@ApiModelProperty("阶段周期结束时间")
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(pattern = "yyyy-MM-dd")
	private Date endTime;
}
