package com.wtkj.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springblade.core.mp.base.BaseEntity;

import javax.validation.constraints.NotNull;
import java.math.BigDecimal;

/**
 * @author Blizzard
 * @create at 2023-09-18 09:20
 * @describe 任务相关合同
 */
@EqualsAndHashCode(callSuper = true)
@TableName("blade_task_contract")
@Data
public class TaskContract extends BaseEntity {

	private static final long serialVersionUID = 1L;

	@TableField("project_id")
	@NotNull(message = "projectId can't be null")
	@JsonSerialize(using = ToStringSerializer.class)
	private Long projectId;

	@TableField("task_id")
	@NotNull(message = "taskId can't be null")
	@JsonSerialize(using = ToStringSerializer.class)
	private Long taskId;

	@TableField("org_dept_id")
	@ApiModelProperty(value = "任务执行机构的顶级id,即乙方")
	@NotNull(message = "orgDeptId can't be null")
	@JsonSerialize(using = ToStringSerializer.class)
	private Long orgDeptId;

	@TableField("blade_file_id")
	@ApiModelProperty(value = "文件上传完返回的主键id")
	private String bladeFileId;

	@TableField("amount")
	@ApiModelProperty(value = "合同金额")
	private BigDecimal amount;

	@TableField("unpaid_amount")
	@ApiModelProperty(value = "未付金额")
	private BigDecimal unpaidAmount;

	@TableField("year")
	@ApiModelProperty(value = "签订年")
	private Integer year;

}
