package com.wtkj.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springblade.core.mp.base.BaseEntity;

/**
 * @author Blizzard
 * @create at 2023-09-15 21:09
 * @describe 任务成果文件
 */
@EqualsAndHashCode(callSuper = true)
@Data
@TableName("blade_task_file")
public class TaskFile extends BaseEntity {

	private static final long serialVersionUID = 1L;


	@JsonSerialize(using = ToStringSerializer.class)
	@TableField("task_id")
	@ApiModelProperty("任务ID")
	private Long taskId;

	//blade_file 主键ID
	@TableField("blade_file_id")
	@JsonSerialize(using = ToStringSerializer.class)
	@ApiModelProperty("文件上传完以后返回的主键id")
	private Long bladeFileId;

	@TableField("is_checked")
	@ApiModelProperty("是否确认")
	private Integer isChecked;
}
