package com.wtkj.feign;

import com.wtkj.entity.WorkStatus;
import com.wtkj.service.IWorkStatusService;
import lombok.AllArgsConstructor;
import org.springblade.core.tenant.annotation.NonDS;
import org.springblade.core.tool.api.R;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author Blizzard
 * @create at 2023-09-25 16:21
 * @describe
 */
@NonDS
@RestController
@AllArgsConstructor
public class OkrClient implements IOkrClient {

	private final IWorkStatusService workStatusService;

	@Override
	@GetMapping(WORK_STATUS)
	public R<WorkStatus> workStatus(Long userId) {
		return R.data(workStatusService.workStatus(userId));
	}
}
