package com.wtkj.service;

import com.wtkj.entity.Project;
import com.wtkj.entity.Task;
import org.springblade.core.secure.BladeUser;

/**
 * @author Blizzard
 * @create at 2023-09-13 16:32
 * @describe
 */
public interface IAsyncService {

	/**
	 * 异步创建项目 阶段 项目权限等处理
	 */
	void createProject(Project project, BladeUser user);

	void createTask(Task task);


	//指定执行单位日志
	// type: 1 指定执行单位 2.指定任务执行部门  3.指定项目经理 4.执行任务执行者 5.指定任务审查者 6.提交任务 7.审查任务 8.二次审查 8.确认 10.取消
	void alterTask(Task afterUpdate, Task beforeUpdate, Long userId);

	//第一次审查通知
	void firstCheck(Long userId, Task task);

	//二次审查通知
	void secondCheck(Long userId, Task task);

	//下达任务通知
	void dispatchTask(Long userId, Task task);

	//通知主管
	void dispatchToDept(Long userId, Task task);

	//通知机构管理员
	void dispatchToOrg(Long userId, Task task);
}
