package com.wtkj.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.wtkj.dto.SearchProjectFileDTO;
import com.wtkj.dto.UploadFileDTO;
import com.wtkj.dto.UploadInnerFileDTO;
import com.wtkj.entity.FileAndFolder;
import com.wtkj.vo.AuthUserInfo;

import java.util.List;
import java.util.Set;

/**
 * @author Blizzard
 * @create at 2023-09-14 16:07
 * @describe 公共service 避免本类调用事务失效的问题
 */
public interface ICommonService {

	boolean uploadFile(List<UploadFileDTO> files);

	boolean coverFile(List<UploadFileDTO> files);

	boolean remove(List<Long> ids);

	boolean move(String ids, Long stageId, Long parentId);

	boolean delete(List<Long> ids);

	boolean uploadInnerFile(List<UploadInnerFileDTO> files);

	IPage<FileAndFolder> esSearch(SearchProjectFileDTO dto, IPage<FileAndFolder> page);

	Set<Integer> openSearchFile(Long projectId, Long fileId, String text);

	AuthUserInfo userInfo();

}
