package com.wtkj.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.wtkj.dto.MyTaskPageDTO;
import com.wtkj.dto.ProjectTaskPageDTO;
import com.wtkj.entity.LineChartDataSet;
import com.wtkj.entity.Task;
import com.wtkj.util.Workload;
import com.wtkj.vo.MyTaskStatistics;
import org.springblade.core.mp.base.BaseService;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * @author Blizzard
 * @create at 2023-09-15 15:18
 * @describe
 */
public interface ITaskService extends BaseService<Task> {
	boolean submit(Task task);

	IPage<Task> projectTaskPage(ProjectTaskPageDTO dto, IPage<Task> page);

	boolean uploadFile(Long taskId, String ids);

	boolean moveFile(Long stageId, Long folderId, String fileIds);

	boolean deleteFile(String ids);

	IPage<Task> myTaskPage(MyTaskPageDTO dto, IPage<Task> page);

	/**
	 * 复用  复用
	 */
	MyTaskStatistics taskStatistics(Long stageId, Integer year, Integer month);


	List<Task> listByUser(Long userId, Integer year, Integer month);


	List<Task> listByStageId(Long stageId);

	List<Task> getByExecute(Long deptId, String userId);

	/**
	 * 用户当日待完成任务
	 */
	List<Task> todayTodo(Long userId, String date);

	/**
	 * 用户当日逾期任务
	 */
	List<Task> todayExpire(Long userId, String date);

	/**
	 * 机构下当日待完成的任务和逾期任务列表
	 */
	List<Task> getByDeptAndDate(Long topDept, Long executeDept, String user, String date);

	/**
	 * 用户当日待完成和逾期的任务
	 */
	List<Task> getTodoAndExpireByUserId(Long userId, String date);

	/**
	 * 机构下当日待完成的任务
	 */
	List<Task> getTodayTodoByOrgDeptId(Long topDept, String date);

	List<Task> getTodoByYear(Set<Long> projectIds, String year);

	/**
	 * 项目任务饼图
	 */
	List<Map<String, String>> projectTaskSummary(Long stageId);

	/**
	 * 项目和项目执行人
	 */
	List<Task> listByUserAndProject(Long userId, Long stageId);

	LineChartDataSet projectTaskSituation(Long stageId);

	LineChartDataSet projectTaskBurnout(Long stageId);

	List<Task> getTodayToExpire(String date);

	List<Workload> exportList(String startDate, String endDate);

	void export(List<Workload> list, HttpServletResponse response) throws IOException;

	List<Task> getByExecuteDept(Long deptId);

	List<Task> getByCompetentUnit(Long deptId);

}
