package com.wtkj.service.impl;

import com.wtkj.entity.ApplyJoin;
import com.wtkj.mapper.ApplyJoinMapper;
import com.wtkj.service.IApplyJoinService;
import io.seata.spring.annotation.GlobalTransactional;
import lombok.AllArgsConstructor;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springblade.system.user.feign.IUserClient;
import org.springframework.stereotype.Service;

/**
 * @author Blizzard
 * @create at 2023-10-06 10:48
 * @describe
 */
@Service
@AllArgsConstructor
public class ApplyJoinServiceImpl extends BaseServiceImpl<ApplyJoinMapper, ApplyJoin> implements IApplyJoinService {

	private final IUserClient userClient;

	@Override
	@GlobalTransactional(rollbackFor = Exception.class)
	public boolean agreeApply(Long id) {
		boolean flag = false;
		ApplyJoin byId = this.getById(id);
		if (byId != null) {
			Long userId = byId.getUserId();
			Long deptId = byId.getDeptId();
			userClient.bindUser(userId, deptId);
			byId.setIsAgree(1);
			flag = this.updateById(byId);
		}
		return flag;
	}
}
