package com.wtkj.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.wtkj.dto.UpdateUserDTO;
import com.wtkj.entity.ContactOuter;
import com.wtkj.mapper.ContactOuterMapper;
import com.wtkj.service.IContactOuterService;
import lombok.AllArgsConstructor;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.Func;
import org.springblade.system.entity.Role;
import org.springblade.system.feign.ISysClient;
import org.springblade.system.user.entity.User;
import org.springblade.system.user.feign.IUserClient;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * @author Blizzard
 * @create at 2023-09-19 11:04
 * @describe
 */
@Service
@AllArgsConstructor
public class ContactOuterServiceImpl extends BaseServiceImpl<ContactOuterMapper, ContactOuter> implements IContactOuterService {

	private final IUserClient userClient;
	private final ISysClient sysClient;

	@Override
	public IPage<ContactOuter> selectPage(Long userId, IPage<ContactOuter> page) {
		return page.setRecords(baseMapper.getPage(userId, page));
	}

	@Override
	public IPage<ContactOuter> contactPage(Long deptId, Long userId, IPage<ContactOuter> page) {
		return page.setRecords(baseMapper.getUserPage(deptId, userId, page));
	}

	@Override
	public boolean updateUser(UpdateUserDTO dto) {
		boolean flag = false;
		Long userId = dto.getId();
		Long roleId = dto.getNewRoleId();
		R<User> userR = userClient.userInfoById(userId);
		if (userR.isSuccess() && userR.getData() != null) {
			User user = Objects.requireNonNull(BeanUtil.copy(dto, User.class));
			if (roleId != null) {
				String roleStr = userR.getData().getRoleId();
				List<Long> roleList = Func.toLongList(roleStr);
				List<Long> temp = new ArrayList<>(roleList);
				if (!CollectionUtils.isEmpty(roleList)) {
					//去掉服务商的相关角色  重新赋值
					List<Role> staffs = sysClient.getRoleList("staff").getData();
					if (!CollectionUtils.isEmpty(staffs)) {
						for (Role staff : staffs) {
							Long id = staff.getId();
							temp.remove(id);
						}
					}
					temp.add(roleId);
					String join = Func.join(temp);
					user.setRoleId(join);
				} else {
					user.setRoleId(String.valueOf(roleId));
				}
			}
			R<Boolean> booleanR = userClient.updateUser(user);
			flag = booleanR.isSuccess();
		}
		return flag;
	}
}
