package com.wtkj.service.impl;

import com.wtkj.entity.DeptToDept;
import com.wtkj.mapper.DeptToDeptMapper;
import com.wtkj.service.IDeptToDeptService;
import lombok.AllArgsConstructor;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.system.entity.Dept;
import org.springblade.system.feign.ISysClient;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * @author Blizzard
 * @create at 2023-09-14 11:11
 * @describe
 */
@Service
@AllArgsConstructor
public class DeptToDeptServiceImpl extends BaseServiceImpl<DeptToDeptMapper, DeptToDept> implements IDeptToDeptService {

	private final ISysClient sysClient;


	@Override
	public List<Dept> getDept(Long topDept, String areaCode, String name, Integer category) {
		List<Dept> result = new ArrayList<>();
		R<List<Dept>> rpc = sysClient.getDeptByAreaCodeAndCategory(areaCode, name, category);
		if (rpc.isSuccess()) {
			List<Dept> data = rpc.getData();
			if (!CollectionUtils.isEmpty(data)) {
				result.addAll(data);
			}
		}
		//机构关联的机构
		if (topDept != null) {
			List<DeptToDept> list = this.getByTopDept(topDept);
			if (!CollectionUtils.isEmpty(list)) {
				List<Dept> deptList = Objects.requireNonNull(BeanUtil.copy(list, Dept.class));
				result.addAll(deptList);
			}
		}
		return result;
	}

	@Override
	public List<DeptToDept> getByTopDept(Long topDept) {
		return baseMapper.selectByTopDept(topDept);
	}


}
