package com.wtkj.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.wtkj.entity.TaskContract;
import com.wtkj.mapper.TaskContractMapper;
import com.wtkj.service.ITaskContractService;
import lombok.AllArgsConstructor;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Set;

/**
 * @author Blizzard
 * @create at 2023-09-18 09:53
 * @describe
 */
@Service
@AllArgsConstructor
public class ITaskContractServiceImpl extends BaseServiceImpl<TaskContractMapper, TaskContract> implements ITaskContractService {

	@Override
	public IPage<TaskContract> pageByTaskId(Long taskId, IPage<TaskContract> page) {
		return page.setRecords(baseMapper.selectByTaskId(taskId, page));
	}

	@Override
	public List<TaskContract> getByProjectIds(Set<Long> projectIds) {
		return baseMapper.getByProjectIds(projectIds);
	}

	@Override
	public List<TaskContract> getByDeptIdAndYear(Long topDept, Integer year, Set<Long> taskIds) {
		return baseMapper.getByOrgDeptId(topDept, year, taskIds);
	}
}
