package com.wtkj.service.impl;

import com.wtkj.entity.ProjectGroup;
import com.wtkj.mapper.ProjectGroupMapper;
import com.wtkj.service.IProjectGroupService;
import lombok.AllArgsConstructor;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springblade.core.tool.utils.CollectionUtil;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.TreeSet;
import java.util.stream.Collectors;

/**
 * @author Blizzard
 * @create at 2023-09-19 21:31
 * @describe
 */
@AllArgsConstructor
@Service
public class ProjectGroupServiceImpl extends BaseServiceImpl<ProjectGroupMapper, ProjectGroup> implements IProjectGroupService {
	@Override
	public List<ProjectGroup> getGroupByStageId(Long stageId) {
		List<ProjectGroup> res = new ArrayList<>();
		List<ProjectGroup> list = baseMapper.selectGroupByStageId(stageId);
		//机构去重
		if (!CollectionUtil.isEmpty(list)) {
			res = list.stream().collect(
				Collectors.collectingAndThen(
					Collectors.toCollection(
						() -> new TreeSet<>(Comparator.comparing(ProjectGroup::getBeInvitedDept))
					), ArrayList::new)
			);
		}
		return res;
	}

	@Override
	public List<ProjectGroup> getUserByBeInvitedDept(Long projectId, Long beInvitedDept) {
		return baseMapper.selectUserByBeInvitedDept(projectId, beInvitedDept);
	}
}
