package com.wtkj.service.impl;

import com.wtkj.entity.ProjectStage;
import com.wtkj.mapper.ProjectStageMapper;
import com.wtkj.service.IProjectStageService;
import lombok.AllArgsConstructor;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springblade.core.redis.cache.BladeRedis;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.time.Instant;
import java.time.LocalDate;
import java.time.ZoneId;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @author Blizzard
 * @create at 2023-09-13 16:50
 * @describe
 */
@Service
@AllArgsConstructor
public class ProjectStageServiceImplService extends BaseServiceImpl<ProjectStageMapper, ProjectStage> implements IProjectStageService {

	private final BladeRedis redis;
	@Override
	public List<ProjectStage> listByProjectId(Long projectId) {
		return baseMapper.selectByProjectId(projectId);
	}

	@Override
	public boolean submit(ProjectStage stage) {
		boolean flag = false;
		if (stage.getId() == null) {
			flag = this.save(stage);
		} else {
			Long id = stage.getId();

			List<LocalDate> dateList = new ArrayList<>();
			Date startTime = stage.getStartTime();
			Date endTime = stage.getEndTime();
			Instant instant = startTime.toInstant();
			Instant instant1 = endTime.toInstant();
			LocalDate start = instant.atZone(ZoneId.systemDefault()).toLocalDate();
			LocalDate end = instant1.atZone(ZoneId.systemDefault()).toLocalDate();
			while (!start.isAfter(end)) {    //判断是否到达结束日期
				dateList.add(start);
				start = start.plusDays(1);  // 加一天
			}
			if (!CollectionUtils.isEmpty(dateList)) {
				redis.set("dateList::" + id, dateList);
			}
			flag = this.updateById(stage);
		}
		return flag;
	}
}
