package com.wtkj.service.impl;

import com.wtkj.entity.TaskLog;
import com.wtkj.mapper.TaskLogMapper;
import com.wtkj.service.ITaskLogService;
import lombok.AllArgsConstructor;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springblade.core.tool.api.R;
import org.springblade.system.user.entity.User;
import org.springblade.system.user.feign.IUserClient;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.*;
import java.util.stream.Collectors;

/**
 * @author Blizzard
 * @create at 2023-09-15 15:56
 * @describe
 */
@Service
@AllArgsConstructor
public class TaskLogServiceImpl extends BaseServiceImpl<TaskLogMapper, TaskLog> implements ITaskLogService {

	private final IUserClient userClient;

	@Override
	public List<TaskLog> listByTaskId(Long taskId) {
		return baseMapper.listByTaskId(taskId);
	}

	@Override
	public List<User> getTaskGroupMen(Long id) {
		List<User> res = new ArrayList<>();
		List<TaskLog> logs = this.listByTaskId(id);
		if (!CollectionUtils.isEmpty(logs)) {
			Set<String> collect = logs.stream().filter(Objects::nonNull).map(TaskLog::getRelatedUser).collect(Collectors.toSet());
			if (!CollectionUtils.isEmpty(collect)) {
				Set<String> idStr = collect.stream().flatMap(s -> Arrays.stream(s.split(","))).collect(Collectors.toSet());
				idStr.forEach(userId -> {
					R<User> userR = userClient.userInfoById(Long.valueOf(userId));
					if (userR.isSuccess()) {
						res.add(userR.getData());
					}
				});
			}
		}
		return res;
	}
}
