package com.wtkj.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.wtkj.entity.TemplateTypeAndStage;
import com.wtkj.mapper.TypeStageMapper;
import com.wtkj.service.ITypeAndStageService;
import lombok.AllArgsConstructor;
import org.springblade.core.log.exception.ServiceException;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author Jimi Zhang
 * @create at 2022-12-12 14:06
 * @describe
 */
@Service
@AllArgsConstructor
public class TypeAndStageServiceImpl extends BaseServiceImpl<TypeStageMapper, TemplateTypeAndStage> implements ITypeAndStageService {


	@Override
	public boolean submit(TemplateTypeAndStage templateTypeAndStage) {
		if (templateTypeAndStage.getId() == null) {
			LambdaQueryWrapper<TemplateTypeAndStage> lqw = Wrappers.lambdaQuery();
			lqw.eq(TemplateTypeAndStage::getName, templateTypeAndStage.getName());
			Long cnt = baseMapper.selectCount(lqw);
			if (cnt > 0L) {
				throw new ServiceException("项目类型或者阶段名称重名,已经存在!");
			}
			return save(templateTypeAndStage);
		} else {
			return updateById(templateTypeAndStage);
		}
	}

	@Override
	public List<TemplateTypeAndStage> getStages(Long projectType) {
		return baseMapper.selectStages(projectType);
	}


}
