package com.wtkj.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.wtkj.entity.WorkStatus;
import com.wtkj.mapper.WorkStatusMapper;
import com.wtkj.service.IWorkStatusService;
import com.wtkj.vo.WorkStatusVO;
import lombok.AllArgsConstructor;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springblade.core.tool.utils.BeanUtil;
import org.springframework.stereotype.Service;

import java.util.Objects;

/**
 * @author Blizzard
 * @create at 2023-09-15 23:55
 * @describe
 */
@AllArgsConstructor
@Service
public class WorkStatusServiceImpl extends BaseServiceImpl<WorkStatusMapper, WorkStatus> implements IWorkStatusService {


	@Override
	public WorkStatusVO workStatus(Long userId) {
		WorkStatusVO vo = new WorkStatusVO();
		LambdaQueryWrapper<WorkStatus> lqw = new LambdaQueryWrapper<>();
		lqw.eq(WorkStatus::getUserId, userId);
		lqw.orderByDesc(WorkStatus::getCreateTime);
		lqw.last("limit 1");
		WorkStatus one = this.getOne(lqw);
		if (one != null) {
			vo = Objects.requireNonNull(BeanUtil.copy(one, WorkStatusVO.class));
		}
		return vo;
	}
}
