package com.wtkj.wrapper;

import com.wtkj.entity.ApplyJoin;
import com.wtkj.vo.ApplyJoinVO;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.SpringUtil;
import org.springblade.system.user.entity.User;
import org.springblade.system.user.feign.IUserClient;

import java.util.Objects;

/**
 * @author Blizzard
 * @create at 2023-10-06 11:00
 * @describe
 */
public class ApplyJoinWrapper extends BaseEntityWrapper<ApplyJoin, ApplyJoinVO> {

	private static IUserClient userClient;

	public static ApplyJoinWrapper build() {
		userClient = SpringUtil.getBean(IUserClient.class);
		return new ApplyJoinWrapper();
	}

	@Override
	public ApplyJoinVO entityVO(ApplyJoin entity) {
		ApplyJoinVO vo = Objects.requireNonNull(BeanUtil.copy(entity, ApplyJoinVO.class));
		Long userId = entity.getUserId();
		R<User> userR = userClient.userInfoById(userId);
		if (userR.isSuccess()) {
			vo.setUser(userR.getData());
		}
		return vo;
	}
}
