package com.wtkj.wrapper;

import com.wtkj.entity.FileAndFolderHistory;
import com.wtkj.vo.FileAndFolderHistoryVO;
import com.wutong.file.feign.IFileClient;
import com.wutong.file.vo.FileVO;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.SpringUtil;
import org.springblade.system.entity.Dept;
import org.springblade.system.feign.ISysClient;
import org.springblade.system.user.entity.User;
import org.springblade.system.user.feign.IUserClient;

import java.util.Objects;

/**
 * @author Blizzard
 * @create at 2023-09-26 14:28
 * @describe
 */
public class FileAndFolderHistoryWrapper extends BaseEntityWrapper<FileAndFolderHistory, FileAndFolderHistoryVO> {

	private static IFileClient fileClient;

	private static IUserClient userClient;

	private static ISysClient sysClient;

	public static FileAndFolderHistoryWrapper build() {

		fileClient = SpringUtil.getBean(IFileClient.class);
		userClient = SpringUtil.getBean(IUserClient.class);
		sysClient = SpringUtil.getBean(ISysClient.class);

		return new FileAndFolderHistoryWrapper();
	}

	@Override
	public FileAndFolderHistoryVO entityVO(FileAndFolderHistory entity) {
		FileAndFolderHistoryVO vo = Objects.requireNonNull(BeanUtil.copy(entity, FileAndFolderHistoryVO.class));
		//覆盖者 覆盖人
		Long createUser = entity.getCreateUser();
		Long createDept = entity.getCreateDept();
		R<User> userR = userClient.userInfoById(createUser);
		if (userR.isSuccess()) {
			vo.setCoverUser(userR.getData().getName());
		}
		R<Dept> deptR = sysClient.getDept(createDept);
		if (deptR.isSuccess()) {
			vo.setCoverDept(deptR.getData().getDeptName());
		}
		//文件
		String historyId = entity.getHistoryId();
		R<FileVO> byId = fileClient.findById(historyId);
		if (byId.isSuccess()) {
			FileVO data = byId.getData();
			vo.setFileVO(data);
			Long createUser1 = data.getCreateUser();
			Long createDept1 = data.getCreateDept();
			R<User> userR1 = userClient.userInfoById(createUser1);
			if (userR1.isSuccess()) {
				vo.setUserName(userR1.getData().getName());
			}
			R<Dept> deptR1 = sysClient.getDept(createDept1);
			if (deptR1.isSuccess()) {
				vo.setDeptName(deptR1.getData().getDeptName());
			}
		}
		return vo;
	}
}
