package com.wtkj.wrapper;

import com.wtkj.entity.ProjectStage;
import com.wtkj.service.IFileAndFolderService;
import com.wtkj.vo.ProjectStageVO;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.SpringUtil;

import java.util.Objects;

/**
 * @author Blizzard
 * @create at 2023-09-28 14:20
 * @describe
 */
public class ProjectStageWrapper extends BaseEntityWrapper<ProjectStage, ProjectStageVO> {

	private static IFileAndFolderService fileAndFolderService;

	public static ProjectStageWrapper build() {
		fileAndFolderService = SpringUtil.getBean(IFileAndFolderService.class);
		return new ProjectStageWrapper();
	}

	@Override
	public ProjectStageVO entityVO(ProjectStage entity) {
		ProjectStageVO vo = Objects.requireNonNull(BeanUtil.copy(entity, ProjectStageVO.class));
		Long stageId = entity.getId();
		Integer amount = fileAndFolderService.getFileAmountByStageId(stageId);
		vo.setFileAmount(amount);
		return vo;
	}
}
