package com.wtkj.wrapper;

import com.wtkj.entity.TaskContract;
import com.wtkj.vo.TaskContractVO;
import com.wutong.file.feign.IFileClient;
import com.wutong.file.vo.FileVO;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.Func;
import org.springblade.core.tool.utils.SpringUtil;
import org.springblade.core.tool.utils.StringUtil;
import org.springblade.system.entity.Dept;
import org.springblade.system.feign.ISysClient;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * @author Blizzard
 * @create at 2023-09-18 10:36
 * @describe
 */
public class TaskContractWrapper extends BaseEntityWrapper<TaskContract, TaskContractVO> {

	private static ISysClient sysClient;
	private static IFileClient fileClient;

	public static TaskContractWrapper build() {
		sysClient = SpringUtil.getBean(ISysClient.class);
		fileClient = SpringUtil.getBean(IFileClient.class);
		return new TaskContractWrapper();
	}

	@Override
	public TaskContractVO entityVO(TaskContract entity) {
		TaskContractVO vo = Objects.requireNonNull(BeanUtil.copy(entity, TaskContractVO.class));
		Long deptId = entity.getOrgDeptId();
		R<Dept> rpc = sysClient.getDept(deptId);
		if (rpc.isSuccess()) {
			vo.setPartyB(rpc.getData().getDeptName());
		}


		String bladeFileIds = entity.getBladeFileId();
		if (StringUtil.isNotBlank(bladeFileIds)) {
			List<FileVO> files = new ArrayList<>();
			List<Long> fileIds = Func.toLongList(bladeFileIds);
			fileIds.forEach(fileId -> {
				R<FileVO> byId = fileClient.findById(fileId);
				if (byId.isSuccess()) {
					files.add(byId.getData());
				}
			});
			vo.setFileVO(files);
		}

		return vo;
	}
}
