package com.wtkj.wrapper;

import com.wtkj.entity.TaskCost;
import com.wtkj.vo.TaskCostVO;
import com.wutong.file.feign.IFileClient;
import com.wutong.file.vo.FileVO;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.Func;
import org.springblade.core.tool.utils.SpringUtil;
import org.springblade.core.tool.utils.StringUtil;
import org.springblade.system.user.entity.User;
import org.springblade.system.user.feign.IUserClient;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * @author Blizzard
 * @create at 2023-09-18 14:29
 * @describe
 */
public class TaskCostWrapper extends BaseEntityWrapper<TaskCost, TaskCostVO> {

	private static IUserClient userClient;
	private static IFileClient fileClient;

	public static TaskCostWrapper build() {
		userClient = SpringUtil.getBean(IUserClient.class);
		fileClient = SpringUtil.getBean(IFileClient.class);
		return new TaskCostWrapper();
	}

	@Override
	public TaskCostVO entityVO(TaskCost entity) {
		TaskCostVO vo = Objects.requireNonNull(BeanUtil.copy(entity, TaskCostVO.class));
		Long createUser = entity.getCreateUser();
		R<User> userR = userClient.userInfoById(createUser);
		if (userR.isSuccess()) {
			vo.setSubmitUser(userR.getData().getName());
		}
		//报销凭证
		String bladeFileIds = entity.getBladeFileIds();
		if (StringUtil.isNotBlank(bladeFileIds)) {
			List<FileVO> files = new ArrayList<>();
			List<Long> fileIds = Func.toLongList(bladeFileIds);
			fileIds.forEach(fileId -> {
				R<FileVO> byId = fileClient.findById(fileId);
				if (byId.isSuccess()) {
					files.add(byId.getData());
				}
			});
			vo.setFiles(files);
		}
		return vo;
	}
}
