package com.wtkj.wrapper;

import com.wtkj.entity.TaskFile;
import com.wtkj.vo.TaskFileVO;
import com.wutong.file.feign.IFileClient;
import com.wutong.file.vo.FileVO;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.SpringUtil;
import org.springblade.system.user.entity.User;
import org.springblade.system.user.feign.IUserClient;

import java.util.Objects;

/**
 * @author Blizzard
 * @create at 2023-09-15 21:49
 * @describe
 */
public class TaskFileWrapper extends BaseEntityWrapper<TaskFile, TaskFileVO> {

	private static IFileClient fileClient;
	private static IUserClient userClient;

	public static TaskFileWrapper build() {
		fileClient = SpringUtil.getBean(IFileClient.class);
		userClient = SpringUtil.getBean(IUserClient.class);
		return new TaskFileWrapper();
	}

	@Override
	public TaskFileVO entityVO(TaskFile entity) {
		TaskFileVO vo = Objects.requireNonNull(BeanUtil.copy(entity, TaskFileVO.class));
		//文件名
		Long fileId = entity.getBladeFileId();
		if (fileId != null) {
			R<FileVO> rpc = fileClient.findById(fileId);
			if (rpc.isSuccess()) {
				vo.setFileVO(rpc.getData());
			}
		}
		//文件上传人
		Long createUser = entity.getCreateUser();
		R<User> rpc = userClient.userInfoById(createUser);
		if (rpc.isSuccess()) {
			vo.setCreateUserName(rpc.getData().getName());
		}
		return vo;
	}
}
