package com.wtkj.wrapper;

import com.wtkj.entity.Task;
import com.wtkj.vo.TaskVO;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.SpringUtil;
import org.springblade.system.entity.Dept;
import org.springblade.system.feign.ISysClient;
import org.springblade.system.user.entity.User;
import org.springblade.system.user.feign.IUserClient;

import java.util.Objects;

/**
 * @author Blizzard
 * @create at 2023-10-09 15:52
 * @describe
 */
public class TaskPageWrapper extends BaseEntityWrapper<Task, TaskVO> {

	private static ISysClient sysClient;
	private static IUserClient userClient;

	public static TaskPageWrapper build() {
		sysClient = SpringUtil.getBean(ISysClient.class);
		userClient = SpringUtil.getBean(IUserClient.class);
		return new TaskPageWrapper();
	}

	@Override
	public TaskVO entityVO(Task entity) {
		TaskVO vo = Objects.requireNonNull(BeanUtil.copy(entity, TaskVO.class));

		//协作单位
		Long orgDeptId = vo.getOrgDeptId();
		if (orgDeptId != null) {
			R<Dept> rpc = sysClient.getDept(orgDeptId);
			if (rpc.isSuccess()) {
				vo.setDispatchUintName(rpc.getData().getDeptName());
			}
		}

		//项目经理
		Long projectManager = vo.getProjectManager();
		if (projectManager != null) {
			R<User> userR = userClient.userInfoById(projectManager);
			if (userR.isSuccess()) {
				vo.setProjectManagerUser(userR.getData().getName());
			}
		}

		return vo;
	}
}
